#----------------------- question 1 ----------------------------------
phi=0.9
tau=sqrt(0.1)
sigma=1
#X0=rnorm(1,0,tau/sqrt(1-phi^2)) # loi stationnaire
X0=-10
n=100
X=rep(0,n+1)
X[1]=X0
Y=rep(0,n+1)
Y[1]=X0+sigma*rnorm(1)
for (i in 1:n){
  X[i+1]=phi*X[i]+tau*rnorm(1)
  Y[i+1]=X[i+1]+sigma*rnorm(1)
}
plot(X, type="l")
points(Y)
#----------------------- question 2 ----------------------------------
nsample=100
Yobs=Y[1:nsample]
plot(Yobs)
#----------------------- question 3 ----------------------------------
K=20000 # number of particles
Xf=matrix(0,nsample,K)
weights=matrix(0,nsample,K)
Weights=matrix(0,nsample,K)
sdInvar=tau/sqrt(1-phi^2)
#Xf[1,]=rnorm(K)*sdInvar # si loi stationnaire
#weights[1,] = dnorm(Xf[1,], 0, sdInvar)*dnorm(Yobs[1], Xf[1,], sigma)
Xf[1,]=Yobs[1]+rnorm(K)*sigma
weights[1,] = dnorm(Yobs[1], Xf[1,], sigma)
Weights[1,] = weights[1,]/ sum(weights[1,])
for (i in 2:nsample){
	Xf[i,] = Xf[i-1,]*phi + tau*rnorm(K) # simulation of the candidates
	weights[i,] = dnorm(Yobs[i], Xf[i,], sigma)
	Weights[i,] = weights[i,]/ sum(weights[i,])
}
Xmean = rowSums(matrix(Weights[nsample,], nsample, K, byrow=TRUE)*Xf)
ind = sample(1:K, 1, prob = weights[nsample,]);
plot(X[1:nsample], type = 'l')
lines(Xf[,ind], col='red')
#lines(Xmean, col="green")
points(Yobs, col="blue")
#----------------------- question 4 ----------------------------------
K=2000 # number of particles
Xf=matrix(0,nsample,K)
weights=matrix(0,nsample,K)
Weights=matrix(0,nsample,K)
sdInvar=tau/sqrt(1-phi^2)
Xf[1,]=Yobs[1]+rnorm(K)*sigma
weights[1,] = dnorm(Yobs[1], Xf[1,], sigma)
Weights[1,] = weights[1,]/ sum(weights[1,])
propvar = tau^2*sigma^2/(tau^2+sigma^2)
for (i in 2:nsample){
  Xf[i,] = propvar*(Xf[i-1,]*phi/(tau^2) +  Yobs[i]/(sigma^2))+ sqrt(propvar)*rnorm(K) # simulation of the candidates
  weights[i,] = dnorm(Yobs[i], Xf[i,], sigma)*dnorm(Xf[i,], phi*Xf[i-1,], tau)/dnorm(Xf[i,],propvar*(Xf[i-1,]*phi/(tau^2) +  Yobs[i]/(sigma^2)), sqrt(propvar))
  Weights[i,] = weights[i,]/ sum(weights[i,])
}
ind = sample(1:K, 1, prob = weights[nsample,]);
plot(X[1:nsample], type = 'l')
lines(Xf[,ind], col='red')
points(Yobs, col="blue")

