#---------------------------------------------------------------------
# Exercise 1
#---------------------------------------------------------------------
#----------------------- question 1 ----------------------------------
phi=-0.1
tau=1
sigma=0.2
X0=-1
n=2
X=rep(0,n+1)
X[1]=X0
V=rep(0,n+1)
V[1]=X0+sigma*rnorm(1)
for (i in 1:n){
  X[i+1]=phi*X[i]+tau*rnorm(1)
  V[i+1]=X[i+1] +sigma*rnorm(1)
}
plot(X, type="l")
points(V)
#----------------------- question 2 ----------------------------------
# random walk MH
k=2
N=10000
qmean = 0
qsd = 0.5
Xchain = rep(0,N+1)
Xchain[1]=0
proba = -1/(2*tau^2)*((Xchain[1]-phi*X[k-1])^2+ (X[k+1]-phi*Xchain[1])^2+ tau^2/sigma^2*(V[k]-Xchain[1])^2)
tauxaccept=0
for (j in 1:N){
  candidat = qmean+qsd*rnorm(1)
  probaC = -1/(2*tau^2)*((candidat-phi*X[k-1])^2+ (X[k+1]-phi*candidat)^2+ tau^2/sigma^2*(V[k]-candidat)^2)
  ratio = probaC-proba
  ratio
  if (log(runif(1))<ratio){
    Xchain[j+1]=candidat
    proba = probaC
    tauxaccept=tauxaccept+1
  }
  else{
    Xchain[j+1]=Xchain[j]
  }
}
tauxaccept/N
plot(Xchain[(N-500):N], type='l')
plot(density(Xchain[(N-500):N]))
abline(v=X[2], col="red")
summary(Xchain[(N-500):N])



#---------------------------------------------------------------------
# Exercise 2
#---------------------------------------------------------------------
#----------------------- question 1 ----------------------------------
phi=-0.1
tau=1
sigma= 0.2
X0=-1
n=100
X=rep(0,n+1)
X[1]=X0
V=rep(0,n+1)
V[1]=X0+sigma*rnorm(1)
for (i in 1:n){
  X[i+1]=phi*X[i]+tau*rnorm(1)
  V[i+1]=X[i+1] +sigma*rnorm(1)
}
plot(X, type="l")
points(V)
#----------------------- question 2 ----------------------------------
# random walk MH
N=10000
Xfilter=V + rnorm(n+1, 0, sigma)
Xfilter[1]=X[1]
Xfilter[n+1]=X[n=1]
qmean = 0
qsd = 1
for (k in 2:n){
  Xchain = rep(0,N+1)
  Xchain[1]=0
  proba = -1/(2*tau^2)*((Xchain[1]-phi*Xfilter[k-1])^2+ (Xfilter[k+1]-phi*Xchain[1])^2+ tau^2/sigma^2*(V[k]-Xchain[1])^2)
  tauxaccept=0
  for (j in 1:N){
    candidat = qmean+qsd*rnorm(1)
    probaC = -1/(2*tau^2)*((candidat-phi*Xfilter[k-1])^2+ (Xfilter[k+1]-phi*candidat)^2+ tau^2/sigma^2*(V[k]-candidat)^2)
    ratio = probaC-proba
    ratio
    if (log(runif(1))<ratio){
      Xchain[j+1]=candidat
      proba = probaC
      tauxaccept=tauxaccept+1
    }
    else{
      Xchain[j+1]=Xchain[j]
    }
  }
  Xfilter[k] = mean(Xchain[(N-100):N])
}
plot(X, type="l")
points(V)
lines(Xfilter, col="red")

